<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="90px" label-position="right" size="small"
                 style="max-width: 500px;">
            <el-form-item prop="receiveAvatar" label="接收人头像">
               <!-- <el-input v-model="formData.receiveAvatar"></el-input>-->
                <el-image style="width: 120px; height: 120px"
                          :src="formData.receiveAvatar" fit="cover"
                          :preview-src-list="[formData.receiveAvatar]">
                    <div slot="error">
                        <el-image style="width: 120px; height: 120px"
                                  src="https://idingdong.oss-cn-hangzhou.aliyuncs.com/image/2020-08-07-17-26-23hRwKPxhh.gif"
                                  fit="cover"/>
                    </div>
                </el-image>
            </el-form-item>
            <el-form-item prop="receiveNickname" label="接收人昵称">
                <el-input v-model="formData.receiveNickname" readonly></el-input>
            </el-form-item>
            <el-form-item prop="title" label="标题">
                <el-input v-model="formData.title" readonly></el-input>
            </el-form-item>
            <el-form-item prop="content" label="内容">
                <el-input type="textarea" v-model="formData.content" readonly></el-input>
            </el-form-item>
            <el-form-item>
                <!--<el-button @click="onSave" :loading="saving"
                           type="primary">保存
                </el-button>-->
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'EmailEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('email/getDto/' + this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {},
                rules: {},
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/email/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/email/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
